<?php
/**
* An example of how to correspond with the sampreg daemon to make SA:MP registrations.
* This script will work for a godfather registration.
*/
$server = "your.samp.server.hostname.here";
$port = 7776;

if (isset($_POST['Register'])) {
	if(isset($_POST['Nick']) && isset($_POST['Age']) && is_numeric($_POST['Age']) && isset($_POST['Password'])) {
		// create an array of the password
		$pass = preg_split('//', $_POST['Password'], -1, PREG_SPLIT_NO_EMPTY);
		$cryptpass = "";
		// Copy the godfather password encryption algorithm
		for($i=0; $i < sizeof($pass); $i++) {
			$char = ord($pass[$i]);
			$char += (3^$i) * ($i % 15);
			//echo $char . "<br>";
			if ($char > 0xff) {
				$char -= 256;
			}
			$cryptpass .= chr($char);
		}
		// Send the message, first line must be the filename.
		$message = 
			$_POST['Nick'] . ".ini\n" . //file to save to
			"Key=".$cryptpass."\n". // Password (must be first line of the file)
			"Registered=1\n". // Registered
			"Sex=".$_POST['Gender']."\n". // Gender (1=mail, 2=female)
			"Age=".$_POST['Age']."\n". // Age
			"Origin=".$_POST['Origin']."\n". // Origin (1=USA, 2=Europe, 3=Asia)
			"Tutorial=".$_POST['Tutorial']."\n"; // Tutorial
		// Create a socket to connect to the sampreg daemon
		$sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
		// Try to connect
		if($sock && socket_connect($sock, $server, $port)) {
			// Write the message
			socket_write($sock, $message);
			// Read the reply
			$result = socket_read($sock, 255, PHP_NORMAL_READ);
			socket_close($sock);
			// Succes?
			if ($result == "Success!\n") {
				echo "Registration complete!";
			}
			// File already exists error ?
			else if (substr($result,0,11) == "Error: File") {
				echo "Someone already registered that name!";
			}
			// ServerError:
			else {
				echo "Server". $result;
			}
		}
		else {
			echo "Warning: Could not connect to server";
		}
	}
	else {
		echo "Error: Please fill in all fields";
	}
}
// HTML Logic
?>
<form method=post>
<table>
<tr>
 <td>Nick:</td>
 <td><input type=text name="Nick"></td>
</tr>
<tr>
 <td>Password: </td>
 <td><input type=password name="Password"></td>
</tr>
<tr>
 <td>Gender: </td>
 <td><select name="Gender"><option value="1">male</option><option value="2">female</option></select></td>
</tr>
<tr>
 <td>Age: </td>
 <td><input type=text name="Age"></td>
</tr>
<tr>
 <td>Origin: </td>
 <td><select name="Origin"><option value="1">USA</option><option value="2">Europe<option value="2">Asia</select></td>
</tr>
<tr>
 <td>Tutorial: </td>
 <td><select name="Tutorial"><option value="0">Yes</option><option value="1">No</option></select></td>
</tr>
<tr><td></td><td><input type=submit value="Register" name="Register"></td></tr>
</table>
</form>

